/*!
 * @file proto_class.h
 * @brief Definition of CmdLinePrefsReader
*/

#ifndef _CMD_LINE_PREFS_READER_H
#define _CMD_LINE_PREFS_READER_H

#include "stdincl.h"
#include "debug.h"

#include "src/lib/argp/argp.h"

typedef struct {
  bool isServer;
  bool isClient;
  char * host;
  char * port;
  char * configFile;
} CmdLineArgs;

typedef struct argp Argp;
typedef struct argp_state ArgpState;

//! A class for reading commandline arguments into Preferences
class CmdLinePrefsReader {

 public:
   CmdLinePrefsReader(int argc, char** argv);
   virtual ~CmdLinePrefsReader();

   static error_t parse_opt(int key, char *arg, ArgpState *state);

 private:
   CmdLineArgs cmdLineArgs;

};

#endif /* _PROTO_CLASS_H */
